variables:
  JOB_HELM_IMAGE: "registry.gitlab.com/operator-ict/golemio/devops/helm/main:1.30.3-3.15.3"

# expects YQ_FILE, YQ_PATH, YQ_VALUE, GIT_PUSH_TOKEN
# optional: SKIP_LATEST_VERSION_WRITE
.update-yq:
  variables:
    GIT_EMAIL: "golemio-robot@operatorict.cz"
    GIT_USERNAME: "oict-robot"
  image: $JOB_HELM_IMAGE
  script:
    #    - set -x
    - |
        echo $YQ_FILE;
        echo $YQ_PATH;
        echo $YQ_VALUE;
        if [[ -z "$YQ_FILE" ]] || [[ -z "$YQ_PATH" ]] || [[ -z "$YQ_VALUE" ]]; then 
          echo "Jedna nebo více environmentálních proměnných (YQ_FILE, YQ_PATH, YQ_VALUE) nejsou nastaveny.";
          exit 1;
        fi
    - if $CI_COMMIT_REF_PROTECTED ; then echo "Ok, this branch is protected."; else echo "This branch is not protected!";exit 1; fi

    - echo "yq eval --inplace "$YQ_PATH=\"$YQ_VALUE\"" $YQ_FILE"
    - yq eval --inplace "$YQ_PATH=\"$YQ_VALUE\"" $YQ_FILE
    - if [ -n "$SKIP_LATEST_VERSION_WRITE" ] ; then exit 0; fi
    - git config --global user.email "$GIT_EMAIL"
    - git config --global user.name "$GIT_USERNAME"
    - git config --global --add safe.directory '*'
    - git add $YQ_FILE
    - git remote set-url --push origin https://group-token:${GIT_PUSH_TOKEN}@gitlab.com/$CI_PROJECT_PATH.git
    - git pull origin $CI_COMMIT_REF_NAME
    - git commit -m "autocommit - update image tag for $YQ_FILE"
    - git push -o ci.skip origin HEAD:$CI_COMMIT_REF_NAME
# #artifact path tady nefunguje dobre, protoze se sestavuje az ve script a je potreba ji definovat u odvozeneho jobu
#  artifacts:
#    paths:
#      - ${YQ_FILE}
#    expire_in: 2 day
#  rules:
#    - if: $CI_PIPELINE_SOURCE == "pipeline"

